/* $NetBSD: netbsd32_sysent.c,v 1.140.2.2 2020/03/08 10:38:10 martin Exp $ */

/*
 * System call switch table.
 *
 * DO NOT EDIT-- this file is automatically generated.
 * created from	NetBSD: syscalls.master,v 1.127.2.2 2020/03/08 10:36:38 martin Exp
 */

#include <sys/cdefs.h>
__KERNEL_RCSID(0, "$NetBSD: netbsd32_sysent.c,v 1.140.2.2 2020/03/08 10:38:10 martin Exp $");

#if defined(_KERNEL_OPT)
#include "opt_compat_netbsd.h"
#include "opt_ntp.h"
#include "opt_compat_43.h"
#include "opt_quota.h"
#endif
#include <sys/param.h>
#include <sys/systm.h>
#include <sys/signal.h>
#include <sys/mount.h>
#include <sys/syscallargs.h>
#include <compat/netbsd32/netbsd32.h>
#include <compat/netbsd32/netbsd32_syscall.h>
#include <compat/netbsd32/netbsd32_syscallargs.h>

#ifdef COMPAT_43
#define	compat_43(func) __CONCAT(compat_43_,func)
#else
#define	compat_43(func) sys_nosys
#endif

#ifdef COMPAT_09
#define	compat_09(func) __CONCAT(compat_09_,func)
#else
#define	compat_09(func) sys_nosys
#endif

#ifdef COMPAT_10
#define	compat_10(func) __CONCAT(compat_10_,func)
#else
#define	compat_10(func) sys_nosys
#endif

#ifdef COMPAT_11
#define	compat_11(func) __CONCAT(compat_11_,func)
#else
#define	compat_11(func) sys_nosys
#endif

#ifdef COMPAT_12
#define	compat_12(func) __CONCAT(compat_12_,func)
#else
#define	compat_12(func) sys_nosys
#endif

#ifdef COMPAT_13
#define	compat_13(func) __CONCAT(compat_13_,func)
#else
#define	compat_13(func) sys_nosys
#endif

#ifdef COMPAT_14
#define	compat_14(func) __CONCAT(compat_14_,func)
#else
#define	compat_14(func) sys_nosys
#endif

#ifdef COMPAT_15
#define	compat_15(func) __CONCAT(compat_15_,func)
#else
#define	compat_15(func) sys_nosys
#endif

#ifdef COMPAT_16
#define	compat_16(func) __CONCAT(compat_16_,func)
#else
#define	compat_16(func) sys_nosys
#endif

#ifdef COMPAT_20
#define	compat_20(func) __CONCAT(compat_20_,func)
#else
#define	compat_20(func) sys_nosys
#endif

#ifdef COMPAT_30
#define	compat_30(func) __CONCAT(compat_30_,func)
#else
#define	compat_30(func) sys_nosys
#endif

#ifdef COMPAT_40
#define	compat_40(func) __CONCAT(compat_40_,func)
#else
#define	compat_40(func) sys_nosys
#endif

#ifdef COMPAT_50
#define	compat_50(func) __CONCAT(compat_50_,func)
#else
#define	compat_50(func) sys_nosys
#endif

#ifdef COMPAT_60
#define	compat_60(func) __CONCAT(compat_60_,func)
#else
#define	compat_60(func) sys_nosys
#endif

#ifdef COMPAT_70
#define	compat_70(func) __CONCAT(compat_70_,func)
#else
#define	compat_70(func) sys_nosys
#endif

#ifdef COMPAT_80
#define	compat_80(func) __CONCAT(compat_80_,func)
#else
#define	compat_80(func) sys_nosys
#endif

#define	s(type)	sizeof(type)
#define	n(type)	(sizeof(type)/sizeof (register32_t))
#define	ns(type)	.sy_narg = n(type), .sy_argsize = s(type)

struct sysent netbsd32_sysent[] = {
	{
		ns(struct netbsd32_syscall_args),
		.sy_flags = SYCALL_INDIRECT,
		.sy_call = (sy_call_t *)netbsd32_syscall
	},		/* 0 = netbsd32_syscall */
	{
		ns(struct netbsd32_exit_args),
		.sy_call = (sy_call_t *)netbsd32_exit
	},		/* 1 = netbsd32_exit */
	{
		.sy_call = (sy_call_t *)sys_fork
	},		/* 2 = fork */
	{
		ns(struct netbsd32_read_args),
		.sy_call = (sy_call_t *)netbsd32_read
	},		/* 3 = netbsd32_read */
	{
		ns(struct netbsd32_write_args),
		.sy_call = (sy_call_t *)netbsd32_write
	},		/* 4 = netbsd32_write */
	{
		ns(struct netbsd32_open_args),
		.sy_call = (sy_call_t *)netbsd32_open
	},		/* 5 = netbsd32_open */
	{
		ns(struct netbsd32_close_args),
		.sy_call = (sy_call_t *)netbsd32_close
	},		/* 6 = netbsd32_close */
	{
		ns(struct compat_50_netbsd32_wait4_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 7 = compat_50_netbsd32_wait4 */
	{
		ns(struct compat_43_netbsd32_ocreat_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 8 = compat_43_netbsd32_ocreat */
	{
		ns(struct netbsd32_link_args),
		.sy_call = (sy_call_t *)netbsd32_link
	},		/* 9 = netbsd32_link */
	{
		ns(struct netbsd32_unlink_args),
		.sy_call = (sy_call_t *)netbsd32_unlink
	},		/* 10 = netbsd32_unlink */
	{
		.sy_call = sys_nosys,
	},		/* 11 = filler */
	{
		ns(struct netbsd32_chdir_args),
		.sy_call = (sy_call_t *)netbsd32_chdir
	},		/* 12 = netbsd32_chdir */
	{
		ns(struct netbsd32_fchdir_args),
		.sy_call = (sy_call_t *)netbsd32_fchdir
	},		/* 13 = netbsd32_fchdir */
	{
		ns(struct compat_50_netbsd32_mknod_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 14 = compat_50_netbsd32_mknod */
	{
		ns(struct netbsd32_chmod_args),
		.sy_call = (sy_call_t *)netbsd32_chmod
	},		/* 15 = netbsd32_chmod */
	{
		ns(struct netbsd32_chown_args),
		.sy_call = (sy_call_t *)netbsd32_chown
	},		/* 16 = netbsd32_chown */
	{
		ns(struct netbsd32_break_args),
		.sy_call = (sy_call_t *)netbsd32_break
	},		/* 17 = netbsd32_break */
	{
		ns(struct compat_20_netbsd32_getfsstat_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 18 = compat_20_netbsd32_getfsstat */
	{
		ns(struct compat_43_netbsd32_olseek_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 19 = compat_43_netbsd32_olseek */
	{
		.sy_call = (sy_call_t *)sys_getpid
	},		/* 20 = getpid */
	{
		ns(struct compat_40_netbsd32_mount_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 21 = compat_40_netbsd32_mount */
	{
		ns(struct netbsd32_unmount_args),
		.sy_call = (sy_call_t *)netbsd32_unmount
	},		/* 22 = netbsd32_unmount */
	{
		ns(struct netbsd32_setuid_args),
		.sy_call = (sy_call_t *)netbsd32_setuid
	},		/* 23 = netbsd32_setuid */
	{
		.sy_call = (sy_call_t *)sys_getuid
	},		/* 24 = getuid */
	{
		.sy_call = (sy_call_t *)sys_geteuid
	},		/* 25 = geteuid */
	{
		ns(struct netbsd32_ptrace_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 26 = netbsd32_ptrace */
	{
		ns(struct netbsd32_recvmsg_args),
		.sy_call = (sy_call_t *)netbsd32_recvmsg
	},		/* 27 = netbsd32_recvmsg */
	{
		ns(struct netbsd32_sendmsg_args),
		.sy_call = (sy_call_t *)netbsd32_sendmsg
	},		/* 28 = netbsd32_sendmsg */
	{
		ns(struct netbsd32_recvfrom_args),
		.sy_call = (sy_call_t *)netbsd32_recvfrom
	},		/* 29 = netbsd32_recvfrom */
	{
		ns(struct netbsd32_accept_args),
		.sy_call = (sy_call_t *)netbsd32_accept
	},		/* 30 = netbsd32_accept */
	{
		ns(struct netbsd32_getpeername_args),
		.sy_call = (sy_call_t *)netbsd32_getpeername
	},		/* 31 = netbsd32_getpeername */
	{
		ns(struct netbsd32_getsockname_args),
		.sy_call = (sy_call_t *)netbsd32_getsockname
	},		/* 32 = netbsd32_getsockname */
	{
		ns(struct netbsd32_access_args),
		.sy_call = (sy_call_t *)netbsd32_access
	},		/* 33 = netbsd32_access */
	{
		ns(struct netbsd32_chflags_args),
		.sy_call = (sy_call_t *)netbsd32_chflags
	},		/* 34 = netbsd32_chflags */
	{
		ns(struct netbsd32_fchflags_args),
		.sy_call = (sy_call_t *)netbsd32_fchflags
	},		/* 35 = netbsd32_fchflags */
	{
		.sy_call = (sy_call_t *)sys_sync
	},		/* 36 = sync */
	{
		ns(struct netbsd32_kill_args),
		.sy_call = (sy_call_t *)netbsd32_kill
	},		/* 37 = netbsd32_kill */
	{
		ns(struct compat_43_netbsd32_stat43_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 38 = compat_43_netbsd32_stat43 */
	{
		.sy_call = (sy_call_t *)sys_getppid
	},		/* 39 = getppid */
	{
		ns(struct compat_43_netbsd32_lstat43_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 40 = compat_43_netbsd32_lstat43 */
	{
		ns(struct netbsd32_dup_args),
		.sy_call = (sy_call_t *)netbsd32_dup
	},		/* 41 = netbsd32_dup */
	{
		.sy_call = (sy_call_t *)sys_pipe
	},		/* 42 = pipe */
	{
		.sy_call = (sy_call_t *)sys_getegid
	},		/* 43 = getegid */
	{
		ns(struct netbsd32_profil_args),
		.sy_call = (sy_call_t *)netbsd32_profil
	},		/* 44 = netbsd32_profil */
	{
		ns(struct netbsd32_ktrace_args),
		.sy_call = (sy_call_t *)netbsd32_ktrace
	},		/* 45 = netbsd32_ktrace */
	{
		ns(struct netbsd32_sigaction_args),
		.sy_call = (sy_call_t *)netbsd32_sigaction
	},		/* 46 = netbsd32_sigaction */
	{
		.sy_call = (sy_call_t *)sys_getgid
	},		/* 47 = getgid */
	{
		ns(struct compat_13_netbsd32_sigprocmask_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 48 = compat_13_sigprocmask13 */
	{
		ns(struct netbsd32___getlogin_args),
		.sy_call = (sy_call_t *)netbsd32___getlogin
	},		/* 49 = netbsd32___getlogin */
	{
		ns(struct netbsd32_setlogin_args),
		.sy_call = (sy_call_t *)netbsd32_setlogin
	},		/* 50 = netbsd32_setlogin */
	{
		ns(struct netbsd32_acct_args),
		.sy_call = (sy_call_t *)netbsd32_acct
	},		/* 51 = netbsd32_acct */
	{
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 52 = compat_13_sigpending13 */
	{
		ns(struct compat_13_netbsd32_sigaltstack13_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 53 = compat_13_netbsd32_sigaltstack13 */
	{
		ns(struct netbsd32_ioctl_args),
		.sy_call = (sy_call_t *)netbsd32_ioctl
	},		/* 54 = netbsd32_ioctl */
	{
		ns(struct compat_12_netbsd32_reboot_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 55 = compat_12_netbsd32_reboot */
	{
		ns(struct netbsd32_revoke_args),
		.sy_call = (sy_call_t *)netbsd32_revoke
	},		/* 56 = netbsd32_revoke */
	{
		ns(struct netbsd32_symlink_args),
		.sy_call = (sy_call_t *)netbsd32_symlink
	},		/* 57 = netbsd32_symlink */
	{
		ns(struct netbsd32_readlink_args),
		.sy_call = (sy_call_t *)netbsd32_readlink
	},		/* 58 = netbsd32_readlink */
	{
		ns(struct netbsd32_execve_args),
		.sy_call = (sy_call_t *)netbsd32_execve
	},		/* 59 = netbsd32_execve */
	{
		ns(struct netbsd32_umask_args),
		.sy_call = (sy_call_t *)netbsd32_umask
	},		/* 60 = netbsd32_umask */
	{
		ns(struct netbsd32_chroot_args),
		.sy_call = (sy_call_t *)netbsd32_chroot
	},		/* 61 = netbsd32_chroot */
	{
		ns(struct compat_43_netbsd32_fstat43_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 62 = compat_43_netbsd32_fstat43 */
	{
		ns(struct compat_43_netbsd32_ogetkerninfo_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 63 = compat_43_netbsd32_ogetkerninfo */
	{
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 64 = compat_43_ogetpagesize */
	{
		ns(struct compat_12_netbsd32_msync_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 65 = compat_12_netbsd32_msync */
	{
		.sy_call = (sy_call_t *)sys_vfork
	},		/* 66 = vfork */
	{
		.sy_call = sys_nosys,
	},		/* 67 = filler */
	{
		.sy_call = sys_nosys,
	},		/* 68 = filler */
	{
		.sy_call = sys_nosys,
	},		/* 69 = filler */
	{
		.sy_call = sys_nosys,
	},		/* 70 = filler */
	{
		ns(struct compat_43_netbsd32_ommap_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 71 = compat_43_netbsd32_ommap */
	{
		ns(struct netbsd32_ovadvise_args),
		.sy_call = (sy_call_t *)netbsd32_ovadvise
	},		/* 72 = vadvise */
	{
		ns(struct netbsd32_munmap_args),
		.sy_call = (sy_call_t *)netbsd32_munmap
	},		/* 73 = netbsd32_munmap */
	{
		ns(struct netbsd32_mprotect_args),
		.sy_call = (sy_call_t *)netbsd32_mprotect
	},		/* 74 = netbsd32_mprotect */
	{
		ns(struct netbsd32_madvise_args),
		.sy_call = (sy_call_t *)netbsd32_madvise
	},		/* 75 = netbsd32_madvise */
	{
		.sy_call = sys_nosys,
	},		/* 76 = filler */
	{
		.sy_call = sys_nosys,
	},		/* 77 = filler */
	{
		ns(struct netbsd32_mincore_args),
		.sy_call = (sy_call_t *)netbsd32_mincore
	},		/* 78 = netbsd32_mincore */
	{
		ns(struct netbsd32_getgroups_args),
		.sy_call = (sy_call_t *)netbsd32_getgroups
	},		/* 79 = netbsd32_getgroups */
	{
		ns(struct netbsd32_setgroups_args),
		.sy_call = (sy_call_t *)netbsd32_setgroups
	},		/* 80 = netbsd32_setgroups */
	{
		.sy_call = (sy_call_t *)sys_getpgrp
	},		/* 81 = getpgrp */
	{
		ns(struct netbsd32_setpgid_args),
		.sy_call = (sy_call_t *)netbsd32_setpgid
	},		/* 82 = netbsd32_setpgid */
	{
		ns(struct compat_50_netbsd32_setitimer_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 83 = compat_50_netbsd32_setitimer */
	{
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 84 = compat_43_owait */
	{
		ns(struct compat_12_netbsd32_oswapon_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 85 = compat_12_netbsd32_oswapon */
	{
		ns(struct compat_50_netbsd32_getitimer_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 86 = compat_50_netbsd32_getitimer */
	{
		ns(struct compat_43_netbsd32_ogethostname_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 87 = compat_43_netbsd32_ogethostname */
	{
		ns(struct compat_43_netbsd32_osethostname_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 88 = compat_43_netbsd32_osethostname */
	{
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 89 = compat_43_ogetdtablesize */
	{
		ns(struct netbsd32_dup2_args),
		.sy_call = (sy_call_t *)netbsd32_dup2
	},		/* 90 = netbsd32_dup2 */
	{
		.sy_call = sys_nosys,
	},		/* 91 = filler */
	{
		ns(struct netbsd32_fcntl_args),
		.sy_call = (sy_call_t *)netbsd32_fcntl
	},		/* 92 = netbsd32_fcntl */
	{
		ns(struct compat_50_netbsd32_select_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 93 = compat_50_netbsd32_select */
	{
		.sy_call = sys_nosys,
	},		/* 94 = filler */
	{
		ns(struct netbsd32_fsync_args),
		.sy_call = (sy_call_t *)netbsd32_fsync
	},		/* 95 = netbsd32_fsync */
	{
		ns(struct netbsd32_setpriority_args),
		.sy_call = (sy_call_t *)netbsd32_setpriority
	},		/* 96 = netbsd32_setpriority */
	{
		ns(struct compat_30_netbsd32_socket_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 97 = compat_30_netbsd32_socket */
	{
		ns(struct netbsd32_connect_args),
		.sy_call = (sy_call_t *)netbsd32_connect
	},		/* 98 = netbsd32_connect */
	{
		ns(struct compat_43_netbsd32_oaccept_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 99 = compat_43_netbsd32_oaccept */
	{
		ns(struct netbsd32_getpriority_args),
		.sy_call = (sy_call_t *)netbsd32_getpriority
	},		/* 100 = netbsd32_getpriority */
	{
		ns(struct compat_43_netbsd32_osend_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 101 = compat_43_netbsd32_osend */
	{
		ns(struct compat_43_netbsd32_orecv_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 102 = compat_43_netbsd32_orecv */
	{
		ns(struct compat_13_netbsd32_sigreturn_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 103 = compat_13_sigreturn13 */
	{
		ns(struct netbsd32_bind_args),
		.sy_call = (sy_call_t *)netbsd32_bind
	},		/* 104 = netbsd32_bind */
	{
		ns(struct netbsd32_setsockopt_args),
		.sy_call = (sy_call_t *)netbsd32_setsockopt
	},		/* 105 = netbsd32_setsockopt */
	{
		ns(struct netbsd32_listen_args),
		.sy_call = (sy_call_t *)netbsd32_listen
	},		/* 106 = netbsd32_listen */
	{
		.sy_call = sys_nosys,
	},		/* 107 = filler */
	{
		ns(struct compat_43_netbsd32_osigvec_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 108 = compat_43_netbsd32_osigvec */
	{
		ns(struct compat_43_netbsd32_sigblock_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 109 = compat_43_netbsd32_sigblock */
	{
		ns(struct compat_43_netbsd32_sigsetmask_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 110 = compat_43_netbsd32_sigsetmask */
	{
		ns(struct compat_13_netbsd32_sigsuspend_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 111 = compat_13_sigsuspend13 */
	{
		ns(struct compat_43_netbsd32_osigstack_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 112 = compat_43_netbsd32_osigstack */
	{
		ns(struct compat_43_netbsd32_orecvmsg_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 113 = compat_43_netbsd32_orecvmsg */
	{
		ns(struct compat_43_netbsd32_osendmsg_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 114 = compat_43_netbsd32_osendmsg */
	{
		.sy_call = sys_nosys,
	},		/* 115 = filler */
	{
		ns(struct compat_50_netbsd32_gettimeofday_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 116 = compat_50_netbsd32_gettimeofday */
	{
		ns(struct compat_50_netbsd32_getrusage_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 117 = compat_50_netbsd32_getrusage */
	{
		ns(struct netbsd32_getsockopt_args),
		.sy_call = (sy_call_t *)netbsd32_getsockopt
	},		/* 118 = netbsd32_getsockopt */
	{
		.sy_call = sys_nosys,
	},		/* 119 = filler */
	{
		ns(struct netbsd32_readv_args),
		.sy_call = (sy_call_t *)netbsd32_readv
	},		/* 120 = netbsd32_readv */
	{
		ns(struct netbsd32_writev_args),
		.sy_call = (sy_call_t *)netbsd32_writev
	},		/* 121 = netbsd32_writev */
	{
		ns(struct compat_50_netbsd32_settimeofday_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 122 = compat_50_netbsd32_settimeofday */
	{
		ns(struct netbsd32_fchown_args),
		.sy_call = (sy_call_t *)netbsd32_fchown
	},		/* 123 = netbsd32_fchown */
	{
		ns(struct netbsd32_fchmod_args),
		.sy_call = (sy_call_t *)netbsd32_fchmod
	},		/* 124 = netbsd32_fchmod */
	{
		ns(struct compat_43_netbsd32_orecvfrom_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 125 = compat_43_netbsd32_orecvfrom */
	{
		ns(struct netbsd32_setreuid_args),
		.sy_call = (sy_call_t *)netbsd32_setreuid
	},		/* 126 = netbsd32_setreuid */
	{
		ns(struct netbsd32_setregid_args),
		.sy_call = (sy_call_t *)netbsd32_setregid
	},		/* 127 = netbsd32_setregid */
	{
		ns(struct netbsd32_rename_args),
		.sy_call = (sy_call_t *)netbsd32_rename
	},		/* 128 = netbsd32_rename */
	{
		ns(struct compat_43_netbsd32_otruncate_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 129 = compat_43_netbsd32_otruncate */
	{
		ns(struct compat_43_netbsd32_oftruncate_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 130 = compat_43_netbsd32_oftruncate */
	{
		ns(struct netbsd32_flock_args),
		.sy_call = (sy_call_t *)netbsd32_flock
	},		/* 131 = netbsd32_flock */
	{
		ns(struct netbsd32_mkfifo_args),
		.sy_call = (sy_call_t *)netbsd32_mkfifo
	},		/* 132 = netbsd32_mkfifo */
	{
		ns(struct netbsd32_sendto_args),
		.sy_call = (sy_call_t *)netbsd32_sendto
	},		/* 133 = netbsd32_sendto */
	{
		ns(struct netbsd32_shutdown_args),
		.sy_call = (sy_call_t *)netbsd32_shutdown
	},		/* 134 = netbsd32_shutdown */
	{
		ns(struct netbsd32_socketpair_args),
		.sy_call = (sy_call_t *)netbsd32_socketpair
	},		/* 135 = netbsd32_socketpair */
	{
		ns(struct netbsd32_mkdir_args),
		.sy_call = (sy_call_t *)netbsd32_mkdir
	},		/* 136 = netbsd32_mkdir */
	{
		ns(struct netbsd32_rmdir_args),
		.sy_call = (sy_call_t *)netbsd32_rmdir
	},		/* 137 = netbsd32_rmdir */
	{
		ns(struct compat_50_netbsd32_utimes_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 138 = compat_50_netbsd32_utimes */
	{
		.sy_call = sys_nosys,
	},		/* 139 = filler */
	{
		ns(struct compat_50_netbsd32_adjtime_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 140 = compat_50_netbsd32_adjtime */
	{
		ns(struct compat_43_netbsd32_ogetpeername_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 141 = compat_43_netbsd32_ogetpeername */
	{
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 142 = compat_43_ogethostid */
	{
		ns(struct compat_43_netbsd32_sethostid_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 143 = compat_43_netbsd32_sethostid */
	{
		ns(struct compat_43_netbsd32_ogetrlimit_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 144 = compat_43_netbsd32_ogetrlimit */
	{
		ns(struct compat_43_netbsd32_osetrlimit_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 145 = compat_43_netbsd32_osetrlimit */
	{
		ns(struct compat_43_netbsd32_killpg_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 146 = compat_43_netbsd32_killpg */
	{
		.sy_call = (sy_call_t *)sys_setsid
	},		/* 147 = setsid */
#if defined(QUOTA) || !defined(_KERNEL_OPT)
	{
		ns(struct compat_50_netbsd32_quotactl_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 148 = compat_50_netbsd32_quotactl */
#else
	{
		.sy_call = sys_nosys,
	},		/* 148 = filler */
#endif
	{
		.sy_call = sys_nosys,
	},		/* 149 = filler */
	{
		ns(struct compat_43_netbsd32_ogetsockname_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 150 = compat_43_netbsd32_ogetsockname */
	{
		.sy_call = sys_nosys,
	},		/* 151 = filler */
	{
		.sy_call = sys_nosys,
	},		/* 152 = filler */
	{
		.sy_call = sys_nosys,
	},		/* 153 = filler */
	{
		.sy_call = sys_nosys,
	},		/* 154 = filler */
	{
		ns(struct netbsd32_nfssvc_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 155 = netbsd32_nfssvc */
	{
		ns(struct compat_43_netbsd32_ogetdirentries_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 156 = compat_43_netbsd32_ogetdirentries */
	{
		ns(struct compat_20_netbsd32_statfs_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 157 = compat_20_netbsd32_statfs */
	{
		ns(struct compat_20_netbsd32_fstatfs_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 158 = compat_20_netbsd32_fstatfs */
	{
		.sy_call = sys_nosys,
	},		/* 159 = filler */
	{
		.sy_call = sys_nosys,
	},		/* 160 = filler */
	{
		ns(struct compat_30_netbsd32_getfh_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 161 = compat_30_netbsd32_getfh */
	{
		ns(struct compat_09_netbsd32_ogetdomainname_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 162 = compat_09_netbsd32_ogetdomainname */
	{
		ns(struct compat_09_netbsd32_osetdomainname_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 163 = compat_09_netbsd32_osetdomainname */
	{
		ns(struct compat_09_netbsd32_uname_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 164 = compat_09_netbsd32_uname */
	{
		ns(struct netbsd32_sysarch_args),
		.sy_call = (sy_call_t *)netbsd32_sysarch
	},		/* 165 = netbsd32_sysarch */
	{
		.sy_call = sys_nosys,
	},		/* 166 = filler */
	{
		.sy_call = sys_nosys,
	},		/* 167 = filler */
	{
		.sy_call = sys_nosys,
	},		/* 168 = filler */
	{
		ns(struct compat_10_netbsd32_semsys_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 169 = compat_10_osemsys */
	{
		ns(struct compat_10_netbsd32_msgsys_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 170 = compat_10_omsgsys */
	{
		ns(struct compat_10_netbsd32_shmsys_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 171 = compat_10_oshmsys */
	{
		.sy_call = sys_nosys,
	},		/* 172 = filler */
	{
		ns(struct netbsd32_pread_args),
		.sy_flags = SYCALL_NARGS64_VAL(1) | SYCALL_ARG4_64,
		.sy_call = (sy_call_t *)netbsd32_pread
	},		/* 173 = netbsd32_pread */
	{
		ns(struct netbsd32_pwrite_args),
		.sy_flags = SYCALL_NARGS64_VAL(1) | SYCALL_ARG4_64,
		.sy_call = (sy_call_t *)netbsd32_pwrite
	},		/* 174 = netbsd32_pwrite */
	{
		ns(struct compat_30_netbsd32_ntp_gettime_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 175 = compat_30_netbsd32_ntp_gettime */
#if defined(NTP) || !defined(_KERNEL_OPT)
	{
		ns(struct netbsd32_ntp_adjtime_args),
		.sy_call = (sy_call_t *)netbsd32_ntp_adjtime
	},		/* 176 = netbsd32_ntp_adjtime */
#else
	{
		.sy_call = sys_nosys,
	},		/* 176 = filler */
#endif
	{
		.sy_call = sys_nosys,
	},		/* 177 = filler */
	{
		.sy_call = sys_nosys,
	},		/* 178 = filler */
	{
		.sy_call = sys_nosys,
	},		/* 179 = filler */
	{
		.sy_call = sys_nosys,
	},		/* 180 = filler */
	{
		ns(struct netbsd32_setgid_args),
		.sy_call = (sy_call_t *)netbsd32_setgid
	},		/* 181 = netbsd32_setgid */
	{
		ns(struct netbsd32_setegid_args),
		.sy_call = (sy_call_t *)netbsd32_setegid
	},		/* 182 = netbsd32_setegid */
	{
		ns(struct netbsd32_seteuid_args),
		.sy_call = (sy_call_t *)netbsd32_seteuid
	},		/* 183 = netbsd32_seteuid */
	{
		.sy_call = sys_nosys,
	},		/* 184 = filler */
	{
		.sy_call = sys_nosys,
	},		/* 185 = filler */
	{
		.sy_call = sys_nosys,
	},		/* 186 = filler */
	{
		.sy_call = sys_nosys,
	},		/* 187 = filler */
	{
		ns(struct compat_12_netbsd32_stat12_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 188 = compat_12_netbsd32_stat12 */
	{
		ns(struct compat_12_netbsd32_fstat12_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 189 = compat_12_netbsd32_fstat12 */
	{
		ns(struct compat_12_netbsd32_lstat12_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 190 = compat_12_netbsd32_lstat12 */
	{
		ns(struct netbsd32_pathconf_args),
		.sy_call = (sy_call_t *)netbsd32_pathconf
	},		/* 191 = netbsd32_pathconf */
	{
		ns(struct netbsd32_fpathconf_args),
		.sy_call = (sy_call_t *)netbsd32_fpathconf
	},		/* 192 = netbsd32_fpathconf */
	{
		ns(struct netbsd32_getsockopt2_args),
		.sy_call = (sy_call_t *)netbsd32_getsockopt2
	},		/* 193 = netbsd32_getsockopt2 */
	{
		ns(struct netbsd32_getrlimit_args),
		.sy_call = (sy_call_t *)netbsd32_getrlimit
	},		/* 194 = netbsd32_getrlimit */
	{
		ns(struct netbsd32_setrlimit_args),
		.sy_call = (sy_call_t *)netbsd32_setrlimit
	},		/* 195 = netbsd32_setrlimit */
	{
		ns(struct compat_12_netbsd32_getdirentries_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 196 = compat_12_netbsd32_getdirentries */
	{
		ns(struct netbsd32_mmap_args),
		.sy_flags = SYCALL_NARGS64_VAL(1) | SYCALL_ARG6_64,
		.sy_call = (sy_call_t *)netbsd32_mmap
	},		/* 197 = netbsd32_mmap */
	{
		ns(struct netbsd32____syscall_args),
		.sy_flags = SYCALL_NARGS64_VAL(1) | SYCALL_ARG0_64 | SYCALL_RET_64 | SYCALL_INDIRECT,
		.sy_call = (sy_call_t *)netbsd32____syscall
	},		/* 198 = netbsd32____syscall */
	{
		ns(struct netbsd32_lseek_args),
		.sy_flags = SYCALL_NARGS64_VAL(1) | SYCALL_ARG2_64 | SYCALL_RET_64,
		.sy_call = (sy_call_t *)netbsd32_lseek
	},		/* 199 = netbsd32_lseek */
	{
		ns(struct netbsd32_truncate_args),
		.sy_flags = SYCALL_NARGS64_VAL(1) | SYCALL_ARG2_64,
		.sy_call = (sy_call_t *)netbsd32_truncate
	},		/* 200 = netbsd32_truncate */
	{
		ns(struct netbsd32_ftruncate_args),
		.sy_flags = SYCALL_NARGS64_VAL(1) | SYCALL_ARG2_64,
		.sy_call = (sy_call_t *)netbsd32_ftruncate
	},		/* 201 = netbsd32_ftruncate */
	{
		ns(struct netbsd32___sysctl_args),
		.sy_call = (sy_call_t *)netbsd32___sysctl
	},		/* 202 = netbsd32___sysctl */
	{
		ns(struct netbsd32_mlock_args),
		.sy_call = (sy_call_t *)netbsd32_mlock
	},		/* 203 = netbsd32_mlock */
	{
		ns(struct netbsd32_munlock_args),
		.sy_call = (sy_call_t *)netbsd32_munlock
	},		/* 204 = netbsd32_munlock */
	{
		ns(struct netbsd32_undelete_args),
		.sy_call = (sy_call_t *)netbsd32_undelete
	},		/* 205 = netbsd32_undelete */
	{
		ns(struct compat_50_netbsd32_futimes_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 206 = compat_50_netbsd32_futimes */
	{
		ns(struct netbsd32_getpgid_args),
		.sy_call = (sy_call_t *)netbsd32_getpgid
	},		/* 207 = netbsd32_getpgid */
	{
		ns(struct netbsd32_reboot_args),
		.sy_call = (sy_call_t *)netbsd32_reboot
	},		/* 208 = netbsd32_reboot */
	{
		ns(struct netbsd32_poll_args),
		.sy_call = (sy_call_t *)netbsd32_poll
	},		/* 209 = netbsd32_poll */
	{
		.sy_call = sys_nosys,
	},		/* 210 = filler */
	{
		.sy_call = sys_nosys,
	},		/* 211 = filler */
	{
		.sy_call = sys_nosys,
	},		/* 212 = filler */
	{
		.sy_call = sys_nosys,
	},		/* 213 = filler */
	{
		.sy_call = sys_nosys,
	},		/* 214 = filler */
	{
		.sy_call = sys_nosys,
	},		/* 215 = filler */
	{
		.sy_call = sys_nosys,
	},		/* 216 = filler */
	{
		.sy_call = sys_nosys,
	},		/* 217 = filler */
	{
		.sy_call = sys_nosys,
	},		/* 218 = filler */
	{
		.sy_call = sys_nosys,
	},		/* 219 = filler */
	{
		ns(struct compat_14_netbsd32___semctl_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 220 = compat_14_netbsd32___semctl */
	{
		ns(struct netbsd32_semget_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 221 = netbsd32_semget */
	{
		ns(struct netbsd32_semop_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 222 = netbsd32_semop */
	{
		ns(struct netbsd32_semconfig_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 223 = netbsd32_semconfig */
	{
		ns(struct compat_14_netbsd32_msgctl_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 224 = compat_14_netbsd32_msgctl */
	{
		ns(struct netbsd32_msgget_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 225 = netbsd32_msgget */
	{
		ns(struct netbsd32_msgsnd_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 226 = netbsd32_msgsnd */
	{
		ns(struct netbsd32_msgrcv_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 227 = netbsd32_msgrcv */
	{
		ns(struct netbsd32_shmat_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 228 = netbsd32_shmat */
	{
		ns(struct compat_14_netbsd32_shmctl_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 229 = compat_14_netbsd32_shmctl */
	{
		ns(struct netbsd32_shmdt_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 230 = netbsd32_shmdt */
	{
		ns(struct netbsd32_shmget_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 231 = netbsd32_shmget */
	{
		ns(struct compat_50_netbsd32_clock_gettime_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 232 = compat_50_netbsd32_clock_gettime */
	{
		ns(struct compat_50_netbsd32_clock_settime_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 233 = compat_50_netbsd32_clock_settime */
	{
		ns(struct compat_50_netbsd32_clock_getres_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 234 = compat_50_netbsd32_clock_getres */
	{
		ns(struct netbsd32_timer_create_args),
		.sy_call = (sy_call_t *)netbsd32_timer_create
	},		/* 235 = netbsd32_timer_create */
	{
		ns(struct netbsd32_timer_delete_args),
		.sy_call = (sy_call_t *)netbsd32_timer_delete
	},		/* 236 = netbsd32_timer_delete */
	{
		ns(struct compat_50_netbsd32_timer_settime_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 237 = compat_50_netbsd32_timer_settime */
	{
		ns(struct compat_50_netbsd32_timer_gettime_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 238 = compat_50_netbsd32_timer_gettime */
	{
		ns(struct netbsd32_timer_getoverrun_args),
		.sy_call = (sy_call_t *)netbsd32_timer_getoverrun
	},		/* 239 = netbsd32_timer_getoverrun */
	{
		ns(struct compat_50_netbsd32_nanosleep_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 240 = compat_50_netbsd32_nanosleep */
	{
		ns(struct netbsd32_fdatasync_args),
		.sy_call = (sy_call_t *)netbsd32_fdatasync
	},		/* 241 = netbsd32_fdatasync */
	{
		ns(struct netbsd32_mlockall_args),
		.sy_call = (sy_call_t *)netbsd32_mlockall
	},		/* 242 = netbsd32_mlockall */
	{
		.sy_call = (sy_call_t *)sys_munlockall
	},		/* 243 = munlockall */
	{
		ns(struct compat_50_netbsd32___sigtimedwait_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 244 = compat_50_netbsd32___sigtimedwait */
	{
		ns(struct netbsd32_sigqueueinfo_args),
		.sy_call = (sy_call_t *)netbsd32_sigqueueinfo
	},		/* 245 = netbsd32_sigqueueinfo */
	{
		ns(struct netbsd32_modctl_args),
		.sy_call = (sy_call_t *)netbsd32_modctl
	},		/* 246 = netbsd32_modctl */
	{
		ns(struct netbsd32__ksem_init_args),
		.sy_call = (sy_call_t *)netbsd32__ksem_init
	},		/* 247 = netbsd32__ksem_init */
	{
		ns(struct netbsd32__ksem_open_args),
		.sy_call = (sy_call_t *)netbsd32__ksem_open
	},		/* 248 = netbsd32__ksem_open */
	{
		ns(struct netbsd32__ksem_unlink_args),
		.sy_call = (sy_call_t *)netbsd32__ksem_unlink
	},		/* 249 = netbsd32__ksem_unlink */
	{
		ns(struct netbsd32__ksem_close_args),
		.sy_call = (sy_call_t *)netbsd32__ksem_close
	},		/* 250 = netbsd32__ksem_close */
	{
		ns(struct netbsd32__ksem_post_args),
		.sy_call = (sy_call_t *)netbsd32__ksem_post
	},		/* 251 = netbsd32__ksem_post */
	{
		ns(struct netbsd32__ksem_wait_args),
		.sy_call = (sy_call_t *)netbsd32__ksem_wait
	},		/* 252 = netbsd32__ksem_wait */
	{
		ns(struct netbsd32__ksem_trywait_args),
		.sy_call = (sy_call_t *)netbsd32__ksem_trywait
	},		/* 253 = netbsd32__ksem_trywait */
	{
		ns(struct netbsd32__ksem_getvalue_args),
		.sy_call = (sy_call_t *)netbsd32__ksem_getvalue
	},		/* 254 = netbsd32__ksem_getvalue */
	{
		ns(struct netbsd32__ksem_destroy_args),
		.sy_call = (sy_call_t *)netbsd32__ksem_destroy
	},		/* 255 = netbsd32__ksem_destroy */
	{
		ns(struct netbsd32__ksem_timedwait_args),
		.sy_call = (sy_call_t *)netbsd32__ksem_timedwait
	},		/* 256 = netbsd32__ksem_timedwait */
	{
		ns(struct netbsd32_mq_open_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 257 = netbsd32_mq_open */
	{
		ns(struct netbsd32_mq_close_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 258 = netbsd32_mq_close */
	{
		ns(struct netbsd32_mq_unlink_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 259 = netbsd32_mq_unlink */
	{
		ns(struct netbsd32_mq_getattr_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 260 = netbsd32_mq_getattr */
	{
		ns(struct netbsd32_mq_setattr_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 261 = netbsd32_mq_setattr */
	{
		ns(struct netbsd32_mq_notify_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 262 = netbsd32_mq_notify */
	{
		ns(struct netbsd32_mq_send_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 263 = netbsd32_mq_send */
	{
		ns(struct netbsd32_mq_receive_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 264 = netbsd32_mq_receive */
	{
		ns(struct compat_50_netbsd32_mq_timedsend_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 265 = compat_50_netbsd32_mq_timedsend */
	{
		ns(struct compat_50_netbsd32_mq_timedreceive_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 266 = compat_50_netbsd32_mq_timedreceive */
	{
		.sy_call = sys_nosys,
	},		/* 267 = filler */
	{
		.sy_call = sys_nosys,
	},		/* 268 = filler */
	{
		.sy_call = sys_nosys,
	},		/* 269 = filler */
	{
		ns(struct netbsd32___posix_rename_args),
		.sy_call = (sy_call_t *)netbsd32___posix_rename
	},		/* 270 = netbsd32___posix_rename */
	{
		ns(struct netbsd32_swapctl_args),
		.sy_call = (sy_call_t *)netbsd32_swapctl
	},		/* 271 = netbsd32_swapctl */
	{
		ns(struct compat_30_netbsd32_getdents_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 272 = compat_30_netbsd32_getdents */
	{
		ns(struct netbsd32_minherit_args),
		.sy_call = (sy_call_t *)netbsd32_minherit
	},		/* 273 = netbsd32_minherit */
	{
		ns(struct netbsd32_lchmod_args),
		.sy_call = (sy_call_t *)netbsd32_lchmod
	},		/* 274 = netbsd32_lchmod */
	{
		ns(struct netbsd32_lchown_args),
		.sy_call = (sy_call_t *)netbsd32_lchown
	},		/* 275 = netbsd32_lchown */
	{
		ns(struct compat_50_netbsd32_lutimes_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 276 = compat_50_netbsd32_lutimes */
	{
		ns(struct netbsd32___msync13_args),
		.sy_call = (sy_call_t *)netbsd32___msync13
	},		/* 277 = netbsd32___msync13 */
	{
		ns(struct compat_30_netbsd32___stat13_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 278 = compat_30_netbsd32___stat13 */
	{
		ns(struct compat_30_netbsd32___fstat13_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 279 = compat_30_netbsd32___fstat13 */
	{
		ns(struct compat_30_netbsd32___lstat13_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 280 = compat_30_netbsd32___lstat13 */
	{
		ns(struct netbsd32___sigaltstack14_args),
		.sy_call = (sy_call_t *)netbsd32___sigaltstack14
	},		/* 281 = netbsd32___sigaltstack14 */
	{
		.sy_call = (sy_call_t *)sys___vfork14
	},		/* 282 = __vfork14 */
	{
		ns(struct netbsd32___posix_chown_args),
		.sy_call = (sy_call_t *)netbsd32___posix_chown
	},		/* 283 = netbsd32___posix_chown */
	{
		ns(struct netbsd32___posix_fchown_args),
		.sy_call = (sy_call_t *)netbsd32___posix_fchown
	},		/* 284 = netbsd32___posix_fchown */
	{
		ns(struct netbsd32___posix_lchown_args),
		.sy_call = (sy_call_t *)netbsd32___posix_lchown
	},		/* 285 = netbsd32___posix_lchown */
	{
		ns(struct netbsd32_getsid_args),
		.sy_call = (sy_call_t *)netbsd32_getsid
	},		/* 286 = netbsd32_getsid */
	{
		ns(struct netbsd32___clone_args),
		.sy_call = (sy_call_t *)netbsd32___clone
	},		/* 287 = netbsd32___clone */
	{
		ns(struct netbsd32_fktrace_args),
		.sy_call = (sy_call_t *)netbsd32_fktrace
	},		/* 288 = netbsd32_fktrace */
	{
		ns(struct netbsd32_preadv_args),
		.sy_flags = SYCALL_NARGS64_VAL(1) | SYCALL_ARG4_64,
		.sy_call = (sy_call_t *)netbsd32_preadv
	},		/* 289 = netbsd32_preadv */
	{
		ns(struct netbsd32_pwritev_args),
		.sy_flags = SYCALL_NARGS64_VAL(1) | SYCALL_ARG4_64,
		.sy_call = (sy_call_t *)netbsd32_pwritev
	},		/* 290 = netbsd32_pwritev */
	{
		ns(struct netbsd32___sigaction14_args),
		.sy_call = (sy_call_t *)netbsd32___sigaction14
	},		/* 291 = netbsd32___sigaction14 */
	{
		ns(struct netbsd32___sigpending14_args),
		.sy_call = (sy_call_t *)netbsd32___sigpending14
	},		/* 292 = netbsd32___sigpending14 */
	{
		ns(struct netbsd32___sigprocmask14_args),
		.sy_call = (sy_call_t *)netbsd32___sigprocmask14
	},		/* 293 = netbsd32___sigprocmask14 */
	{
		ns(struct netbsd32___sigsuspend14_args),
		.sy_call = (sy_call_t *)netbsd32___sigsuspend14
	},		/* 294 = netbsd32___sigsuspend14 */
	{
		ns(struct compat_16_netbsd32___sigreturn14_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 295 = compat_16_netbsd32___sigreturn14 */
	{
		ns(struct netbsd32___getcwd_args),
		.sy_call = (sy_call_t *)netbsd32___getcwd
	},		/* 296 = netbsd32___getcwd */
	{
		ns(struct netbsd32_fchroot_args),
		.sy_call = (sy_call_t *)netbsd32_fchroot
	},		/* 297 = netbsd32_fchroot */
	{
		ns(struct compat_30_netbsd32_fhopen_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 298 = compat_30_netbsd32_fhopen */
	{
		ns(struct compat_30_netbsd32_fhstat_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 299 = compat_30_netbsd32_fhstat */
	{
		ns(struct compat_20_netbsd32_fhstatfs_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 300 = compat_20_netbsd32_fhstatfs */
	{
		ns(struct compat_50_netbsd32___semctl14_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 301 = compat_50_netbsd32___semctl14 */
	{
		ns(struct compat_50_netbsd32___msgctl13_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 302 = compat_50_netbsd32___msgctl13 */
	{
		ns(struct compat_50_netbsd32___shmctl13_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 303 = compat_50_netbsd32___shmctl13 */
	{
		ns(struct netbsd32_lchflags_args),
		.sy_call = (sy_call_t *)netbsd32_lchflags
	},		/* 304 = netbsd32_lchflags */
	{
		.sy_call = (sy_call_t *)sys_issetugid
	},		/* 305 = issetugid */
	{
		ns(struct netbsd32_utrace_args),
		.sy_call = (sy_call_t *)netbsd32_utrace
	},		/* 306 = netbsd32_utrace */
	{
		ns(struct netbsd32_getcontext_args),
		.sy_call = (sy_call_t *)netbsd32_getcontext
	},		/* 307 = netbsd32_getcontext */
	{
		ns(struct netbsd32_setcontext_args),
		.sy_call = (sy_call_t *)netbsd32_setcontext
	},		/* 308 = netbsd32_setcontext */
	{
		ns(struct netbsd32__lwp_create_args),
		.sy_call = (sy_call_t *)netbsd32__lwp_create
	},		/* 309 = netbsd32__lwp_create */
	{
		.sy_call = (sy_call_t *)sys__lwp_exit
	},		/* 310 = _lwp_exit */
	{
		.sy_call = (sy_call_t *)sys__lwp_self
	},		/* 311 = _lwp_self */
	{
		ns(struct netbsd32__lwp_wait_args),
		.sy_call = (sy_call_t *)netbsd32__lwp_wait
	},		/* 312 = netbsd32__lwp_wait */
	{
		ns(struct netbsd32__lwp_suspend_args),
		.sy_call = (sy_call_t *)netbsd32__lwp_suspend
	},		/* 313 = netbsd32__lwp_suspend */
	{
		ns(struct netbsd32__lwp_continue_args),
		.sy_call = (sy_call_t *)netbsd32__lwp_continue
	},		/* 314 = netbsd32__lwp_continue */
	{
		ns(struct netbsd32__lwp_wakeup_args),
		.sy_call = (sy_call_t *)netbsd32__lwp_wakeup
	},		/* 315 = netbsd32__lwp_wakeup */
	{
		.sy_call = (sy_call_t *)sys__lwp_getprivate
	},		/* 316 = _lwp_getprivate */
	{
		ns(struct netbsd32__lwp_setprivate_args),
		.sy_call = (sy_call_t *)netbsd32__lwp_setprivate
	},		/* 317 = netbsd32__lwp_setprivate */
	{
		ns(struct netbsd32__lwp_kill_args),
		.sy_call = (sy_call_t *)netbsd32__lwp_kill
	},		/* 318 = netbsd32__lwp_kill */
	{
		ns(struct netbsd32__lwp_detach_args),
		.sy_call = (sy_call_t *)netbsd32__lwp_detach
	},		/* 319 = netbsd32__lwp_detach */
	{
		ns(struct compat_50_netbsd32__lwp_park_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 320 = compat_50_netbsd32__lwp_park */
	{
		ns(struct netbsd32__lwp_unpark_args),
		.sy_call = (sy_call_t *)netbsd32__lwp_unpark
	},		/* 321 = netbsd32__lwp_unpark */
	{
		ns(struct netbsd32__lwp_unpark_all_args),
		.sy_call = (sy_call_t *)netbsd32__lwp_unpark_all
	},		/* 322 = netbsd32__lwp_unpark_all */
	{
		ns(struct netbsd32__lwp_setname_args),
		.sy_call = (sy_call_t *)netbsd32__lwp_setname
	},		/* 323 = netbsd32__lwp_setname */
	{
		ns(struct netbsd32__lwp_getname_args),
		.sy_call = (sy_call_t *)netbsd32__lwp_getname
	},		/* 324 = netbsd32__lwp_getname */
	{
		ns(struct netbsd32__lwp_ctl_args),
		.sy_call = (sy_call_t *)netbsd32__lwp_ctl
	},		/* 325 = netbsd32__lwp_ctl */
	{
		.sy_call = sys_nosys,
	},		/* 326 = filler */
	{
		.sy_call = sys_nosys,
	},		/* 327 = filler */
	{
		.sy_call = sys_nosys,
	},		/* 328 = filler */
	{
		.sy_call = sys_nosys,
	},		/* 329 = filler */
	{
		.sy_call = sys_nosys,
	},		/* 330 = filler */
	{
		.sy_call = sys_nosys,
	},		/* 331 = filler */
	{
		.sy_call = sys_nosys,
	},		/* 332 = filler */
	{
		.sy_call = sys_nosys,
	},		/* 333 = filler */
	{
		.sy_call = sys_nosys,
	},		/* 334 = filler */
	{
		.sy_call = sys_nosys,
	},		/* 335 = filler */
	{
		.sy_call = sys_nosys,
	},		/* 336 = filler */
	{
		.sy_call = sys_nosys,
	},		/* 337 = filler */
	{
		.sy_call = sys_nosys,
	},		/* 338 = filler */
	{
		.sy_call = sys_nosys,
	},		/* 339 = filler */
	{
		ns(struct netbsd32___sigaction_sigtramp_args),
		.sy_call = (sy_call_t *)netbsd32___sigaction_sigtramp
	},		/* 340 = netbsd32___sigaction_sigtramp */
	{
		.sy_call = sys_nosys,
	},		/* 341 = filler */
	{
		.sy_call = sys_nosys,
	},		/* 342 = filler */
	{
		ns(struct netbsd32_rasctl_args),
		.sy_call = (sy_call_t *)netbsd32_rasctl
	},		/* 343 = netbsd32_rasctl */
	{
		.sy_call = (sy_call_t *)sys_kqueue
	},		/* 344 = kqueue */
	{
		ns(struct compat_50_netbsd32_kevent_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 345 = compat_50_netbsd32_kevent */
	{
		ns(struct netbsd32__sched_setparam_args),
		.sy_call = (sy_call_t *)netbsd32__sched_setparam
	},		/* 346 = netbsd32__sched_setparam */
	{
		ns(struct netbsd32__sched_getparam_args),
		.sy_call = (sy_call_t *)netbsd32__sched_getparam
	},		/* 347 = netbsd32__sched_getparam */
	{
		ns(struct netbsd32__sched_setaffinity_args),
		.sy_call = (sy_call_t *)netbsd32__sched_setaffinity
	},		/* 348 = netbsd32__sched_setaffinity */
	{
		ns(struct netbsd32__sched_getaffinity_args),
		.sy_call = (sy_call_t *)netbsd32__sched_getaffinity
	},		/* 349 = netbsd32__sched_getaffinity */
	{
		.sy_call = (sy_call_t *)sys_sched_yield
	},		/* 350 = sched_yield */
	{
		ns(struct netbsd32__sched_protect_args),
		.sy_call = (sy_call_t *)netbsd32__sched_protect
	},		/* 351 = netbsd32__sched_protect */
	{
		.sy_call = sys_nosys,
	},		/* 352 = filler */
	{
		.sy_call = sys_nosys,
	},		/* 353 = filler */
	{
		ns(struct netbsd32_fsync_range_args),
		.sy_flags = SYCALL_NARGS64_VAL(2) | SYCALL_ARG3_64 | SYCALL_ARG2_64,
		.sy_call = (sy_call_t *)netbsd32_fsync_range
	},		/* 354 = netbsd32_fsync_range */
	{
		ns(struct netbsd32_uuidgen_args),
		.sy_call = (sy_call_t *)netbsd32_uuidgen
	},		/* 355 = netbsd32_uuidgen */
	{
		ns(struct netbsd32_getvfsstat_args),
		.sy_call = (sy_call_t *)netbsd32_getvfsstat
	},		/* 356 = netbsd32_getvfsstat */
	{
		ns(struct netbsd32_statvfs1_args),
		.sy_call = (sy_call_t *)netbsd32_statvfs1
	},		/* 357 = netbsd32_statvfs1 */
	{
		ns(struct netbsd32_fstatvfs1_args),
		.sy_call = (sy_call_t *)netbsd32_fstatvfs1
	},		/* 358 = netbsd32_fstatvfs1 */
	{
		ns(struct compat_30_netbsd32_fhstatvfs1_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 359 = compat_30_netbsd32_fhstatvfs1 */
	{
		ns(struct netbsd32_extattrctl_args),
		.sy_call = (sy_call_t *)netbsd32_extattrctl
	},		/* 360 = netbsd32_extattrctl */
	{
		ns(struct netbsd32_extattr_set_file_args),
		.sy_call = (sy_call_t *)netbsd32_extattr_set_file
	},		/* 361 = netbsd32_extattr_set_file */
	{
		ns(struct netbsd32_extattr_get_file_args),
		.sy_call = (sy_call_t *)netbsd32_extattr_get_file
	},		/* 362 = netbsd32_extattr_get_file */
	{
		ns(struct netbsd32_extattr_delete_file_args),
		.sy_call = (sy_call_t *)netbsd32_extattr_delete_file
	},		/* 363 = netbsd32_extattr_delete_file */
	{
		ns(struct netbsd32_extattr_set_fd_args),
		.sy_call = (sy_call_t *)netbsd32_extattr_set_fd
	},		/* 364 = netbsd32_extattr_set_fd */
	{
		ns(struct netbsd32_extattr_get_fd_args),
		.sy_call = (sy_call_t *)netbsd32_extattr_get_fd
	},		/* 365 = netbsd32_extattr_get_fd */
	{
		ns(struct netbsd32_extattr_delete_fd_args),
		.sy_call = (sy_call_t *)netbsd32_extattr_delete_fd
	},		/* 366 = netbsd32_extattr_delete_fd */
	{
		ns(struct netbsd32_extattr_set_link_args),
		.sy_call = (sy_call_t *)netbsd32_extattr_set_link
	},		/* 367 = netbsd32_extattr_set_link */
	{
		ns(struct netbsd32_extattr_get_link_args),
		.sy_call = (sy_call_t *)netbsd32_extattr_get_link
	},		/* 368 = netbsd32_extattr_get_link */
	{
		ns(struct netbsd32_extattr_delete_link_args),
		.sy_call = (sy_call_t *)netbsd32_extattr_delete_link
	},		/* 369 = netbsd32_extattr_delete_link */
	{
		ns(struct netbsd32_extattr_list_fd_args),
		.sy_call = (sy_call_t *)netbsd32_extattr_list_fd
	},		/* 370 = netbsd32_extattr_list_fd */
	{
		ns(struct netbsd32_extattr_list_file_args),
		.sy_call = (sy_call_t *)netbsd32_extattr_list_file
	},		/* 371 = netbsd32_extattr_list_file */
	{
		ns(struct netbsd32_extattr_list_link_args),
		.sy_call = (sy_call_t *)netbsd32_extattr_list_link
	},		/* 372 = netbsd32_extattr_list_link */
	{
		ns(struct compat_50_netbsd32_pselect_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 373 = compat_50_netbsd32_pselect */
	{
		ns(struct compat_50_netbsd32_pollts_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 374 = compat_50_netbsd32_pollts */
	{
		ns(struct netbsd32_setxattr_args),
		.sy_call = (sy_call_t *)netbsd32_setxattr
	},		/* 375 = netbsd32_setxattr */
	{
		ns(struct netbsd32_lsetxattr_args),
		.sy_call = (sy_call_t *)netbsd32_lsetxattr
	},		/* 376 = netbsd32_lsetxattr */
	{
		ns(struct netbsd32_fsetxattr_args),
		.sy_call = (sy_call_t *)netbsd32_fsetxattr
	},		/* 377 = netbsd32_fsetxattr */
	{
		ns(struct netbsd32_getxattr_args),
		.sy_call = (sy_call_t *)netbsd32_getxattr
	},		/* 378 = netbsd32_getxattr */
	{
		ns(struct netbsd32_lgetxattr_args),
		.sy_call = (sy_call_t *)netbsd32_lgetxattr
	},		/* 379 = netbsd32_lgetxattr */
	{
		ns(struct netbsd32_fgetxattr_args),
		.sy_call = (sy_call_t *)netbsd32_fgetxattr
	},		/* 380 = netbsd32_fgetxattr */
	{
		ns(struct netbsd32_listxattr_args),
		.sy_call = (sy_call_t *)netbsd32_listxattr
	},		/* 381 = netbsd32_listxattr */
	{
		ns(struct netbsd32_llistxattr_args),
		.sy_call = (sy_call_t *)netbsd32_llistxattr
	},		/* 382 = netbsd32_llistxattr */
	{
		ns(struct netbsd32_flistxattr_args),
		.sy_call = (sy_call_t *)netbsd32_flistxattr
	},		/* 383 = netbsd32_flistxattr */
	{
		ns(struct netbsd32_removexattr_args),
		.sy_call = (sy_call_t *)netbsd32_removexattr
	},		/* 384 = netbsd32_removexattr */
	{
		ns(struct netbsd32_lremovexattr_args),
		.sy_call = (sy_call_t *)netbsd32_lremovexattr
	},		/* 385 = netbsd32_lremovexattr */
	{
		ns(struct netbsd32_fremovexattr_args),
		.sy_call = (sy_call_t *)netbsd32_fremovexattr
	},		/* 386 = netbsd32_fremovexattr */
	{
		ns(struct compat_50_netbsd32___stat30_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 387 = compat_50_netbsd32___stat30 */
	{
		ns(struct compat_50_netbsd32___fstat30_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 388 = compat_50_netbsd32___fstat30 */
	{
		ns(struct compat_50_netbsd32___lstat30_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 389 = compat_50_netbsd32___lstat30 */
	{
		ns(struct netbsd32___getdents30_args),
		.sy_call = (sy_call_t *)netbsd32___getdents30
	},		/* 390 = netbsd32___getdents30 */
	{
		.sy_call = (sy_call_t *)nullop,
	},		/* 391 = filler */
	{
		ns(struct compat_30_netbsd32___fhstat30_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 392 = compat_30_netbsd32___fhstat30 */
	{
		ns(struct compat_50_netbsd32_ntp_gettime_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 393 = compat_50_netbsd32_ntp_gettime */
	{
		ns(struct netbsd32___socket30_args),
		.sy_call = (sy_call_t *)netbsd32___socket30
	},		/* 394 = netbsd32___socket30 */
	{
		ns(struct netbsd32___getfh30_args),
		.sy_call = (sy_call_t *)netbsd32___getfh30
	},		/* 395 = netbsd32___getfh30 */
	{
		ns(struct netbsd32___fhopen40_args),
		.sy_call = (sy_call_t *)netbsd32___fhopen40
	},		/* 396 = netbsd32___fhopen40 */
	{
		ns(struct netbsd32___fhstatvfs140_args),
		.sy_call = (sy_call_t *)netbsd32___fhstatvfs140
	},		/* 397 = netbsd32___fhstatvfs140 */
	{
		ns(struct compat_50_netbsd32___fhstat40_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 398 = compat_50_netbsd32___fhstat40 */
	{
		.sy_call = sys_nosys,
	},		/* 399 = filler */
	{
		.sy_call = sys_nosys,
	},		/* 400 = filler */
	{
		.sy_call = sys_nosys,
	},		/* 401 = filler */
	{
		.sy_call = sys_nosys,
	},		/* 402 = filler */
	{
		.sy_call = sys_nosys,
	},		/* 403 = filler */
	{
		.sy_call = sys_nosys,
	},		/* 404 = filler */
	{
		.sy_call = sys_nosys,
	},		/* 405 = filler */
	{
		.sy_call = sys_nosys,
	},		/* 406 = filler */
	{
		.sy_call = sys_nosys,
	},		/* 407 = filler */
	{
		.sy_call = sys_nosys,
	},		/* 408 = filler */
	{
		.sy_call = sys_nosys,
	},		/* 409 = filler */
	{
		ns(struct netbsd32___mount50_args),
		.sy_call = (sy_call_t *)netbsd32___mount50
	},		/* 410 = netbsd32___mount50 */
	{
		ns(struct netbsd32_mremap_args),
		.sy_call = (sy_call_t *)netbsd32_mremap
	},		/* 411 = netbsd32_mremap */
	{
		ns(struct netbsd32_pset_create_args),
		.sy_call = (sy_call_t *)netbsd32_pset_create
	},		/* 412 = netbsd32_pset_create */
	{
		ns(struct netbsd32_pset_destroy_args),
		.sy_call = (sy_call_t *)netbsd32_pset_destroy
	},		/* 413 = netbsd32_pset_destroy */
	{
		ns(struct netbsd32_pset_assign_args),
		.sy_call = (sy_call_t *)netbsd32_pset_assign
	},		/* 414 = netbsd32_pset_assign */
	{
		ns(struct netbsd32__pset_bind_args),
		.sy_call = (sy_call_t *)netbsd32__pset_bind
	},		/* 415 = netbsd32__pset_bind */
	{
		ns(struct netbsd32___posix_fadvise50_args),
		.sy_flags = SYCALL_NARGS64_VAL(2) | SYCALL_ARG3_64 | SYCALL_ARG2_64,
		.sy_call = (sy_call_t *)netbsd32___posix_fadvise50
	},		/* 416 = netbsd32___posix_fadvise50 */
	{
		ns(struct netbsd32___select50_args),
		.sy_call = (sy_call_t *)netbsd32___select50
	},		/* 417 = netbsd32___select50 */
	{
		ns(struct netbsd32___gettimeofday50_args),
		.sy_call = (sy_call_t *)netbsd32___gettimeofday50
	},		/* 418 = netbsd32___gettimeofday50 */
	{
		ns(struct netbsd32___settimeofday50_args),
		.sy_call = (sy_call_t *)netbsd32___settimeofday50
	},		/* 419 = netbsd32___settimeofday50 */
	{
		ns(struct netbsd32___utimes50_args),
		.sy_call = (sy_call_t *)netbsd32___utimes50
	},		/* 420 = netbsd32___utimes50 */
	{
		ns(struct netbsd32___adjtime50_args),
		.sy_call = (sy_call_t *)netbsd32___adjtime50
	},		/* 421 = netbsd32___adjtime50 */
	{
		.sy_call = sys_nosys,
	},		/* 422 = filler */
	{
		ns(struct netbsd32___futimes50_args),
		.sy_call = (sy_call_t *)netbsd32___futimes50
	},		/* 423 = netbsd32___futimes50 */
	{
		ns(struct netbsd32___lutimes50_args),
		.sy_call = (sy_call_t *)netbsd32___lutimes50
	},		/* 424 = netbsd32___lutimes50 */
	{
		ns(struct netbsd32___setitimer50_args),
		.sy_call = (sy_call_t *)netbsd32___setitimer50
	},		/* 425 = netbsd32___setitimer50 */
	{
		ns(struct netbsd32___getitimer50_args),
		.sy_call = (sy_call_t *)netbsd32___getitimer50
	},		/* 426 = netbsd32___getitimer50 */
	{
		ns(struct netbsd32___clock_gettime50_args),
		.sy_call = (sy_call_t *)netbsd32___clock_gettime50
	},		/* 427 = netbsd32___clock_gettime50 */
	{
		ns(struct netbsd32___clock_settime50_args),
		.sy_call = (sy_call_t *)netbsd32___clock_settime50
	},		/* 428 = netbsd32___clock_settime50 */
	{
		ns(struct netbsd32___clock_getres50_args),
		.sy_call = (sy_call_t *)netbsd32___clock_getres50
	},		/* 429 = netbsd32___clock_getres50 */
	{
		ns(struct netbsd32___nanosleep50_args),
		.sy_call = (sy_call_t *)netbsd32___nanosleep50
	},		/* 430 = netbsd32___nanosleep50 */
	{
		ns(struct netbsd32_____sigtimedwait50_args),
		.sy_call = (sy_call_t *)netbsd32_____sigtimedwait50
	},		/* 431 = netbsd32_____sigtimedwait50 */
	{
		ns(struct netbsd32___mq_timedsend50_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 432 = netbsd32___mq_timedsend50 */
	{
		ns(struct netbsd32___mq_timedreceive50_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 433 = netbsd32___mq_timedreceive50 */
	{
		ns(struct compat_60_netbsd32__lwp_park_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 434 = compat_60_netbsd32__lwp_park */
	{
		ns(struct netbsd32___kevent50_args),
		.sy_call = (sy_call_t *)netbsd32___kevent50
	},		/* 435 = netbsd32___kevent50 */
	{
		ns(struct netbsd32___pselect50_args),
		.sy_call = (sy_call_t *)netbsd32___pselect50
	},		/* 436 = netbsd32___pselect50 */
	{
		ns(struct netbsd32___pollts50_args),
		.sy_call = (sy_call_t *)netbsd32___pollts50
	},		/* 437 = netbsd32___pollts50 */
	{
		.sy_call = sys_nosys,
	},		/* 438 = filler */
	{
		ns(struct netbsd32___stat50_args),
		.sy_call = (sy_call_t *)netbsd32___stat50
	},		/* 439 = netbsd32___stat50 */
	{
		ns(struct netbsd32___fstat50_args),
		.sy_call = (sy_call_t *)netbsd32___fstat50
	},		/* 440 = netbsd32___fstat50 */
	{
		ns(struct netbsd32___lstat50_args),
		.sy_call = (sy_call_t *)netbsd32___lstat50
	},		/* 441 = netbsd32___lstat50 */
	{
		ns(struct netbsd32_____semctl50_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 442 = netbsd32_____semctl50 */
	{
		ns(struct netbsd32___shmctl50_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 443 = netbsd32___shmctl50 */
	{
		ns(struct netbsd32___msgctl50_args),
		.sy_call = (sy_call_t *)sys_nomodule
	},		/* 444 = netbsd32___msgctl50 */
	{
		ns(struct netbsd32___getrusage50_args),
		.sy_call = (sy_call_t *)netbsd32___getrusage50
	},		/* 445 = netbsd32___getrusage50 */
	{
		ns(struct netbsd32___timer_settime50_args),
		.sy_call = (sy_call_t *)netbsd32___timer_settime50
	},		/* 446 = netbsd32___timer_settime50 */
	{
		ns(struct netbsd32___timer_gettime50_args),
		.sy_call = (sy_call_t *)netbsd32___timer_gettime50
	},		/* 447 = netbsd32___timer_gettime50 */
#if defined(NTP) || !defined(_KERNEL_OPT)
	{
		ns(struct netbsd32___ntp_gettime50_args),
		.sy_call = (sy_call_t *)netbsd32___ntp_gettime50
	},		/* 448 = netbsd32___ntp_gettime50 */
#else
	{
		.sy_call = sys_nosys,
	},		/* 448 = filler */
#endif
	{
		ns(struct netbsd32___wait450_args),
		.sy_call = (sy_call_t *)netbsd32___wait450
	},		/* 449 = netbsd32___wait450 */
	{
		ns(struct netbsd32___mknod50_args),
		.sy_flags = SYCALL_NARGS64_VAL(1) | SYCALL_ARG2_64,
		.sy_call = (sy_call_t *)netbsd32___mknod50
	},		/* 450 = netbsd32___mknod50 */
	{
		ns(struct netbsd32___fhstat50_args),
		.sy_call = (sy_call_t *)netbsd32___fhstat50
	},		/* 451 = netbsd32___fhstat50 */
	{
		.sy_call = sys_nosys,
	},		/* 452 = filler */
	{
		ns(struct netbsd32_pipe2_args),
		.sy_call = (sy_call_t *)netbsd32_pipe2
	},		/* 453 = netbsd32_pipe2 */
	{
		ns(struct netbsd32_dup3_args),
		.sy_call = (sy_call_t *)netbsd32_dup3
	},		/* 454 = netbsd32_dup3 */
	{
		ns(struct netbsd32_kqueue1_args),
		.sy_call = (sy_call_t *)netbsd32_kqueue1
	},		/* 455 = netbsd32_kqueue1 */
	{
		ns(struct netbsd32_paccept_args),
		.sy_call = (sy_call_t *)netbsd32_paccept
	},		/* 456 = netbsd32_paccept */
	{
		ns(struct netbsd32_linkat_args),
		.sy_call = (sy_call_t *)netbsd32_linkat
	},		/* 457 = netbsd32_linkat */
	{
		ns(struct netbsd32_renameat_args),
		.sy_call = (sy_call_t *)netbsd32_renameat
	},		/* 458 = netbsd32_renameat */
	{
		ns(struct netbsd32_mkfifoat_args),
		.sy_call = (sy_call_t *)netbsd32_mkfifoat
	},		/* 459 = netbsd32_mkfifoat */
	{
		ns(struct netbsd32_mknodat_args),
		.sy_flags = SYCALL_NARGS64_VAL(1) | SYCALL_ARG4_64,
		.sy_call = (sy_call_t *)netbsd32_mknodat
	},		/* 460 = netbsd32_mknodat */
	{
		ns(struct netbsd32_mkdirat_args),
		.sy_call = (sy_call_t *)netbsd32_mkdirat
	},		/* 461 = netbsd32_mkdirat */
	{
		ns(struct netbsd32_faccessat_args),
		.sy_call = (sy_call_t *)netbsd32_faccessat
	},		/* 462 = netbsd32_faccessat */
	{
		ns(struct netbsd32_fchmodat_args),
		.sy_call = (sy_call_t *)netbsd32_fchmodat
	},		/* 463 = netbsd32_fchmodat */
	{
		ns(struct netbsd32_fchownat_args),
		.sy_call = (sy_call_t *)netbsd32_fchownat
	},		/* 464 = netbsd32_fchownat */
	{
		ns(struct netbsd32_fexecve_args),
		.sy_call = (sy_call_t *)netbsd32_fexecve
	},		/* 465 = netbsd32_fexecve */
	{
		ns(struct netbsd32_fstatat_args),
		.sy_call = (sy_call_t *)netbsd32_fstatat
	},		/* 466 = netbsd32_fstatat */
	{
		ns(struct netbsd32_utimensat_args),
		.sy_call = (sy_call_t *)netbsd32_utimensat
	},		/* 467 = netbsd32_utimensat */
	{
		ns(struct netbsd32_openat_args),
		.sy_call = (sy_call_t *)netbsd32_openat
	},		/* 468 = netbsd32_openat */
	{
		ns(struct netbsd32_readlinkat_args),
		.sy_call = (sy_call_t *)netbsd32_readlinkat
	},		/* 469 = netbsd32_readlinkat */
	{
		ns(struct netbsd32_symlinkat_args),
		.sy_call = (sy_call_t *)netbsd32_symlinkat
	},		/* 470 = netbsd32_symlinkat */
	{
		ns(struct netbsd32_unlinkat_args),
		.sy_call = (sy_call_t *)netbsd32_unlinkat
	},		/* 471 = netbsd32_unlinkat */
	{
		ns(struct netbsd32_futimens_args),
		.sy_call = (sy_call_t *)netbsd32_futimens
	},		/* 472 = netbsd32_futimens */
#if defined(QUOTA) || !defined(_KERNEL_OPT)
	{
		ns(struct netbsd32___quotactl_args),
		.sy_call = (sy_call_t *)netbsd32___quotactl
	},		/* 473 = netbsd32___quotactl */
#else
	{
		.sy_call = sys_nosys,
	},		/* 473 = filler */
#endif
	{
		ns(struct netbsd32_posix_spawn_args),
		.sy_call = (sy_call_t *)netbsd32_posix_spawn
	},		/* 474 = netbsd32_posix_spawn */
	{
		ns(struct netbsd32_recvmmsg_args),
		.sy_call = (sy_call_t *)netbsd32_recvmmsg
	},		/* 475 = netbsd32_recvmmsg */
	{
		ns(struct netbsd32_sendmmsg_args),
		.sy_call = (sy_call_t *)netbsd32_sendmmsg
	},		/* 476 = netbsd32_sendmmsg */
	{
		ns(struct netbsd32_clock_nanosleep_args),
		.sy_call = (sy_call_t *)netbsd32_clock_nanosleep
	},		/* 477 = netbsd32_clock_nanosleep */
	{
		ns(struct netbsd32____lwp_park60_args),
		.sy_call = (sy_call_t *)netbsd32____lwp_park60
	},		/* 478 = netbsd32____lwp_park60 */
	{
		ns(struct netbsd32_posix_fallocate_args),
		.sy_flags = SYCALL_NARGS64_VAL(2) | SYCALL_ARG3_64 | SYCALL_ARG2_64,
		.sy_call = (sy_call_t *)netbsd32_posix_fallocate
	},		/* 479 = netbsd32_posix_fallocate */
	{
		ns(struct netbsd32_fdiscard_args),
		.sy_flags = SYCALL_NARGS64_VAL(2) | SYCALL_ARG3_64 | SYCALL_ARG2_64,
		.sy_call = (sy_call_t *)netbsd32_fdiscard
	},		/* 480 = netbsd32_fdiscard */
	{
		ns(struct netbsd32_wait6_args),
		.sy_call = (sy_call_t *)netbsd32_wait6
	},		/* 481 = netbsd32_wait6 */
	{
		ns(struct netbsd32_clock_getcpuclockid2_args),
		.sy_call = (sy_call_t *)netbsd32_clock_getcpuclockid2
	},		/* 482 = netbsd32_clock_getcpuclockid2 */
	{
		.sy_call = sys_nosys,
	},		/* 483 = filler */
	{
		.sy_call = sys_nosys,
	},		/* 484 = filler */
	{
		.sy_call = sys_nosys,
	},		/* 485 = filler */
	{
		.sy_call = sys_nosys,
	},		/* 486 = filler */
	{
		.sy_call = sys_nosys,
	},		/* 487 = filler */
	{
		.sy_call = sys_nosys,
	},		/* 488 = filler */
	{
		.sy_call = sys_nosys,
	},		/* 489 = filler */
	{
		.sy_call = sys_nosys,
	},		/* 490 = filler */
	{
		.sy_call = sys_nosys,
	},		/* 491 = filler */
	{
		.sy_call = sys_nosys,
	},		/* 492 = filler */
	{
		.sy_call = sys_nosys,
	},		/* 493 = filler */
	{
		.sy_call = sys_nosys,
	},		/* 494 = filler */
	{
		.sy_call = sys_nosys,
	},		/* 495 = filler */
	{
		.sy_call = sys_nosys,
	},		/* 496 = filler */
	{
		.sy_call = sys_nosys,
	},		/* 497 = filler */
	{
		.sy_call = sys_nosys,
	},		/* 498 = filler */
	{
		.sy_call = sys_nosys,
	},		/* 499 = filler */
	{
		.sy_call = sys_nosys,
	},		/* 500 = filler */
	{
		.sy_call = sys_nosys,
	},		/* 501 = filler */
	{
		.sy_call = sys_nosys,
	},		/* 502 = filler */
	{
		.sy_call = sys_nosys,
	},		/* 503 = filler */
	{
		.sy_call = sys_nosys,
	},		/* 504 = filler */
	{
		.sy_call = sys_nosys,
	},		/* 505 = filler */
	{
		.sy_call = sys_nosys,
	},		/* 506 = filler */
	{
		.sy_call = sys_nosys,
	},		/* 507 = filler */
	{
		.sy_call = sys_nosys,
	},		/* 508 = filler */
	{
		.sy_call = sys_nosys,
	},		/* 509 = filler */
	{
		.sy_call = sys_nosys,
	},		/* 510 = filler */
	{
		.sy_call = sys_nosys,
	},		/* 511 = filler */
};

const uint32_t netbsd32_sysent_nomodbits[] = {
	0x042c4180,	/* syscalls   0- 31 */
	0xc0b10140,	/* syscalls  32- 63 */
	0x23f80083,	/* syscalls  64- 95 */
	0x2437f0ea,	/* syscalls  96-127 */
	0x7857f406,	/* syscalls 128-159 */
	0x70008e1e,	/* syscalls 160-191 */
	0xf0004010,	/* syscalls 192-223 */
	0x001167ff,	/* syscalls 224-255 */
	0x01d107fe,	/* syscalls 256-287 */
	0x0000fc80,	/* syscalls 288-319 */
	0x02000001,	/* syscalls 320-351 */
	0x00600080,	/* syscalls 352-383 */
	0x00004338,	/* syscalls 384-415 */
	0x1c070000,	/* syscalls 416-447 */
	0x00000000,	/* syscalls 448-479 */
	0x00000000,	/* syscalls 480-511 */
};
